/* user configurable options. */

#define SLEEPER 20	/* You may need to adjust this for a faster machine */

#define PASSSPEED 100000 /* How much cpu to eat, smaller == more cpu */

#define LCDMODEDEFAULT 7 /* Default mode of the display. */

/*  lp0 0x3bc lp1 0x378 lp2 0x278 ... etc */
#define LCD_D_PORT	0x278	/* lp1 i/o port for lcd data writes (8 bits) */


/* end of user configurable options. */


#define LCD_MAX 1

#include "release.h"

#ifndef DRIVER
#include <linux/tty.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <pwd.h>
#include <termcap.h>
#include <termios.h>
#include <signal.h>
#include <setjmp.h>
#include <time.h>
#include <utmp.h>
#include <math.h>
#include <ctype.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#endif

#if LINUX_VERSION_CODE >= KERNEL_VER(2,2,0) 
#include <asm/current.h>
#endif
/* #include <linux/sched.h> */

#ifdef DRIVER
#include <linux/mm.h>
#include <linux/delay.h>
/* #include <unistd.h> */
#include <linux/errno.h>
#include <linux/major.h>
#include <asm/io.h>
#if LINUX_VERSION_CODE >= KERNEL_VER(2,1,6)
#include <asm/uaccess.h>
#else
#include <asm/segment.h>
#endif
#include <asm/system.h>
#include <linux/module.h>


/* 
some macros to lessen bloat of driver file.
Might want to place it in macros.h?
Makes driver run faster at expense of RAM.
*/

#ifndef OBSOLETE
#define FAST	busy_lcd();
#define SLOW
#else
#define FAST
#define SLOW 	udelay(SLEEPER); outb(0,LCD_D_PORT);
#endif
                                                                

#define CONTROLWRITE(TEXT, SZ, CNT) if (SZ == 0) { \
		FAST outb (0, LCD_D_PORT); \
      		outb (255-LCD_RW-16, LCD_C_PORT); \
		udelay(SLEEPER);  \
      		outb (255-LCD_RW-LCD_EN-16, LCD_C_PORT); \
      		outb (255-LCD_RW-16, LCD_C_PORT); SLOW \
    	} else { \
    	while (CNT<SZ) { \
      		FAST outb (TEXT[cnt], LCD_D_PORT); \
      		outb (255-LCD_RW-16, LCD_C_PORT); \
		udelay(SLEEPER);  \
      		outb (255-LCD_RW-LCD_EN-16, LCD_C_PORT); \
      		CNT++; \
      		outb (255-LCD_RW-16, LCD_C_PORT); SLOW \
	} }



#define DATAWRITE(TEXT, SZ, CNT)     	if (SZ == 0) { \
		FAST outb (0, LCD_D_PORT); \
      		outb (255-LCD_RW-LCD_RS-16, LCD_C_PORT); \
		udelay(SLEEPER); \
      		outb (255-LCD_RW-(LCD_EN|LCD_RS)-16, LCD_C_PORT); \
      		outb (255-LCD_RW-LCD_RS-16, LCD_C_PORT); SLOW \
    	} else { \
    	while (CNT<SZ) { \
		FAST \
      		outb (TEXT[cnt], LCD_D_PORT); \
      		outb (255-LCD_RW-LCD_RS-16, LCD_C_PORT); \
		udelay(SLEEPER);  \
      		outb (255-LCD_RW-(LCD_EN|LCD_RS)-16, LCD_C_PORT); \
      		cnt++; \
      		outb (255-LCD_RW-LCD_RS-16, LCD_C_PORT); SLOW \
	} }







/* END of macro definitions */



#endif


#define LCD_DATASIZE sizeof (struct LCD_DATA_TYPE)
#define LCD_TRUE 1
#define LCD_FALSE 0
#define LCD_S_PORT LCD_D_PORT+1 /* i/o port for lcd status lines */
#define LCD_C_PORT LCD_D_PORT+2	/* i/o port for lcd control lines */
#define LCD_RS		0x02	/* RS line, 0=control  1=data */
#define LCD_EN		0x01	/* EN line, 0->1 enable */
#define LCD_BSY		0x80	/* return signal from display indicating busy */
#define LCD_RW		0x04    /* R/W line */

#define LCD_SETCONTROL	0x01   /* sets subsequent writes to be ctrl writes */
#define LCD_SETDATA	0x02   /* sets subsequent writes to be data writes */

#define LCD_GET_ALL		0x07	/*get the whole LCD_DATA[minor] struct*/
#define LCD_SET_ALL		0x08	/*set the whole LCD_DATA[minor] struct
						  except LCD_BUSY!*/

#define LCD_INITSTRING "\074\074\074\074\006\014\001\002\200"
#define LCD_CLEARSTRING "\001\002"


#define MODE_CONTROL 0x01
#define MODE_DATA    0x02

struct LCD_DATA_TYPE {
  char text[81];
};

/* This struct is used for misc data about the lcd*/

struct LCD_DATA_SAVE_TYPE {
	int BUSY;		/*lcd is in use*/
	int mode;               /* mode (control or data) */
};

#define LCD_MAJOR		23

#define LCD_RC "/etc/lcdrc"


#ifndef LCDD
	extern char template[100][100], graphArray[6]; 
 	extern int te_users[20][3],te_net[20][3],te_cpu[20][3], te_time[20][3],
		te_load[20][4],te_procinfo[20][4], proc_flags, last_users;
	extern unsigned long long last_nice, last_sys, last_idle, last_user;
	extern float elapsed_time;
	extern double il_f, il_w, il_l;
#endif

#ifndef LCDROOT
	#ifndef DRIVER
		/* lcdroot.c */
		extern void lcd_draw_bar (int fd, int pixels, int pos);
		extern void lcd_pos (int fd, int pos);
		extern void lcd_write (int fd, char *str);
		extern void lcd_init (int fd);
		extern void lcd_open (int *fd);
		extern void lcd_clear (int fd);
		extern void lcd_gRAM (int fd, int add);
		extern void dump_char_data (int fd, char *bfr, int rpos);
	#endif
#endif

#ifdef LCDD
	/* lcdtime.c */
	extern void drawclock(int fd, int pass);
	/* lcdcpu.c */
	extern void init_cpustat (void);
	extern void draw_cpugraph (int fd, int pass);
	/* lcdload.c */
	extern void drawload(int fd, int pass);
	/* lcdmem.c */
	extern void draw_memswap (int fd, int pass);
	/* lcdnet.c */
	extern void draw_net (int fd,int pass);
	/* lcdprocinfo.c */
	extern void draw_proc (int fd,int pass);
	extern int proc_get_method(void);
	extern void update_proc (int fd,int method);
	/* lcdusers.c */
	extern void draw_users(int fd,int pass);
	/* lcdgraph.c */
	extern void pos_graph_cpumem(int fd, int pass);
	extern void pos_graph_net(int fd, int pass);
	extern void init_charset (int fd);
#endif
