/*

Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

Some Parts Copyright 1991-1995 Stephen S. Richardson (prefect@wpi.edu)
based off of several versions for several hardware and software platforms
from 1991-1995.

from the top.c copyright from procps
 * Copyright (c) 1992 Branko Lankester
 * Copyright (c) 1992 Roger Binns


10/23/94	S.Richardson	0.1	Initial version

10/26/94	S.Richardson	0.2	More revisions

01/??/95	S.Richardson	0.3	More revisions again.

02/02/95	S.Richardson	0.42	"release"

07/30/95	S.Richardson	0.50	"release 2" - cleanup for newer kernels.

02/20/97	Andrew J. Kroll	0.51	Real-time display and support for 16x2.

02/20/97	Andrew J. Kroll 0.51	Fixed nasty bug locks up anything on
					IRQ "shared" with LPT card :-O

08/19/97 	David Williams	0.51	Stole top.c code for processes
					and added 24x2 display

08/23/97	Phil Schwan	0.51	Fixed CPU tick counter
					Fixed user counting function

08/23/97	Andrew J. Kroll	0.51	merged David's and Phil's work in
					strightened the cpu meters to stagger.
					processing files the way top does eats
					CPU like a wild whore... need to fix it

08/24/97	David Williams	0.51	added lcd.rc for templated display

08/30/97	Andrew J. Kroll 0.51	fixed rc file parsing, ripped entire
					file into nice small digestable pieces.
					finalized template traversing.

03/18/99	Andrew J. Kroll 0.52	SMP aware for cpu stats

*/

#define LCDD

#include "lcd.h"

#include "globals.h"

static int procop=1;

void create_template(int fd,int lcd_x,int lcd_y,int lcd_pass,char *sprintfString)
{
	char command[256], oprand[256];
	int i;
	/* hmmm precalc it... good idea, next version :-) */

	/*	int i=0,spot=0;
	spot= (64 * *lcd_x) + *lcd_y;
	*/


	/* parse out the functions */
	/* we have x, y, pass, and a string wich starts with the function name, followed by oprands */
	/* get the command */
	sscanf(sprintfString,"%s",command);
	
	/* build out flags */
	if(!strcmp(command,"time")) {
	/* time will copy it's self to location+10 also if pass < 10 we can blink */
		te_time[lcd_pass][2]=0; /* do the time function on this pass */
		te_time[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_time[lcd_pass][0]=lcd_x; /* draw it at column X */	
		if(lcd_pass<10) {
			te_time[lcd_pass+10][2]=0; /* do the time function on this pass */
			te_time[lcd_pass+10][1]=lcd_y; /* draw it at line Y */
			te_time[lcd_pass+10][0]=lcd_x; /* draw it at column X */	
		}
	
	} else if(!strcmp(command,"netiog")) {
		te_net[lcd_pass][2]=0;
		te_net[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_net[lcd_pass][0]=lcd_x; /* draw it at column X */
		netflag=1; /* process network activity in real time */

	


	/*
	cpu and mem/swap follow each other around on the display
	so we ignore positioning fields for the mem/swap
	*/
	} else if(!strcmp(command,"cpug")) {
		te_cpu[lcd_pass][2]=0;
		te_cpu[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_cpu[lcd_pass][0]=lcd_x; /* draw it at column X */
		cpuflag=1; /* process cpu activity in real time */
	} else if(!strcmp(command,"memswapg")) {
		memflag=1; /* indicate simple memory updates, once per pass */





/* process counts */
	} else if(!strcmp(command,"proc")) {
		procflag=1; /* indicate simple proc count updates, once per pass */
/* 
pull out oprand, the number or text are accepted
sleeping=1, stopped=2, zombie=3, running=4
total=5, disksleep=6, paging=7 
*/
		sscanf(sprintfString,"proc %s",oprand);
		if(!strcmp(oprand,"sleeping") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=1; procop=1; 
		} else 
		if(!strcmp(oprand,"stopped") || !strcmp(oprand,"2")) {
			te_procinfo[lcd_pass][3]=2; procop=2;
		} else 
		if(!strcmp(oprand,"zombie") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=3; procop=3;
		} else 
		if(!strcmp(oprand,"running") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=4; procop=4;
		} else 
		if(!strcmp(oprand,"total") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=5; procop=5;
		} else 
		if(!strcmp(oprand,"disksleep") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=6; procop=6;
		} else 
		if(!strcmp(oprand,"paging") || !strcmp(oprand,"1")) {
			te_procinfo[lcd_pass][3]=7; procop=7;
		} else {
		te_procinfo[lcd_pass][3]=procop; procop++;
		if(procop>7)procop=1;
		}	
		te_procinfo[lcd_pass][2]=0;
		te_procinfo[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_procinfo[lcd_pass][0]=lcd_x; /* draw it at column X */
		
	} else if(!strcmp(command,"users")) {
		te_users[lcd_pass][2]=0;
		te_users[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_users[lcd_pass][0]=lcd_x; /* draw it at column X */
		
	} else if(!strcmp(command,"loadbarg")) {
		te_load[lcd_pass][2]=0;
		te_load[lcd_pass][1]=lcd_y; /* draw it at line Y */
		te_load[lcd_pass][0]=lcd_x; /* draw it at column X */
		i=11; /* default to 11 segment bar */
		sscanf(sprintfString,"loadbarg %i",&i);
		te_load[lcd_pass][3]=i;
				

/*	} else if(.....) {
				etc ... */


/* real time displays will copy themselves from pass to 19
this way they always update.
note that I have time copy it's self to a place
that makes the colon flash...

the text function that I'll add in after you fill in the skeleton
will have the higest priority, so that it can erase stuff.

in order to prevent flicker, I reccomend that we poop eveything out to
a 'virtual LCD' (actually, just a string) first, then slap it out all at once.
but for now, this will do fine... It also allows some interesting effects.

*/	
	}
}

void open_lcdrc(int fd)
{
	char sprintfString[256], commentbuffer[256];
	int i,lcd_line,lcd_char,lcd_pass,procmethod,qm;
	FILE *rc;

	procmethod=proc_get_method();

	rc = fopen(LCD_RC, "r");

	for(i=0;i<21;i++) {
		te_users[i][2]=-1;
		te_net[i][2]=-1;
		te_cpu[i][2]=-1;
		te_time[i][2]=-1;
		te_load[i][2]=-1;
		te_procinfo[i][2]=-1;
	}

	if (rc < 0) perror ("No /etc/lcdrc file.. MAKE ONE!\n"); else 
				while(!feof(rc)) {
		fgets(sprintfString,255,rc);
		/* lowercase it */
		for(i=0;i<strlen(sprintfString); i++) { 
			sprintfString[i]=tolower(sprintfString[i]);
			if(sprintfString[i]=='"') break;
			if(sprintfString[i]=='#') break;
			}
		strcpy(commentbuffer,sprintfString);

		/* slickly check for comment only/blank/garbage line */
		lcd_pass=(-500);
		sscanf(sprintfString,"%i %i %i %[^\n]",&lcd_line,&lcd_char,&lcd_pass,sprintfString);
		qm=0l;
		/* chop off comment */
		sprintf(sprintfString,"%s#\n",sprintfString);
		for(i=0;i<strlen(sprintfString); i++) {
			if(sprintfString[i]=='"') qm=qm ^ 1;
			if(sprintfString[i]=='/') i++;
			if((sprintfString[i]=='#') && (qm == 0)) {
				sprintfString[i]=0x0a;
				sprintfString[i+1]=0x00; break;
			}
		}
		
		if(lcd_pass!= (-500)){ /* not a garbage line */
#ifdef DEBUG
			printf("%1.1i %2.1i %2.1i %s",lcd_line,lcd_char,lcd_pass,sprintfString);
#endif
			create_template(fd,lcd_char,lcd_line,lcd_pass,sprintfString);
		} else {
#ifdef DEBUG
			printf("%s",commentbuffer); 
#endif
			strcpy(sprintfString," "); 
			strcpy(commentbuffer,sprintfString);
		}
	}

	printf("\n\nRC file parsed, running...\n\n");
	/* traverse the template array forever */
#ifdef FORK
	if( fork() != 0 ) exit(1);
	setsid();
#endif
	for(i=0;;) {

		if(i == 0 && procflag==1) update_proc(fd,procmethod);
		
		if(i == 1 && memflag==1) draw_memswap (fd, i);
		if (netflag == 1) draw_net (fd, i);
		if (cpuflag == 1) draw_cpugraph (fd, i);
		if(te_time[i][2] == 0) drawclock(fd,i);
		if(te_cpu[i][2] == 0) pos_graph_cpumem(fd, i);
		if(te_net[i][2] == 0) pos_graph_net(fd, i);
		if(te_procinfo[i][2] == 0) draw_proc (fd, i);
		if(te_users[i][2] == 0) draw_users(fd,i);
		if(te_load[i][2] == 0) drawload(fd,i);
		i++;
		if(i == 20) i=0; /* reset for another loop */
		usleep(PASSSPEED);
	}
}

void help(char *argv[]) 
{
	printf("%s 0.52\n",argv[0]);
	printf("Syntax --\n");
	printf("%s [ Mode ]\n",argv[0]);
	printf(
/*
		"\t1 - 16x2 display, pseudo hi-res.\n"
		"\t2 - 16x2 display, pseudo hi-res with net activity.\n"
		"\t3 - 16x2 display, no pseudo hi-res.\n"
		"\t4 - 24x2 display, pseudo hi-res with net activity and process list.\n"
		"\t5 - 40x2 display, one computer\n"
		"\t6 - 40x2 display, two computers\n" 
*/
		"\t7 - Do-it-yourself template (default)\n\n"
		);
}


void exit_stage_left(int fd)
{
	/* do we ever really get here? */
	/* Clean exit */
	close(fd);
	exit (0);
}



void process_it(int fd, int display) 
{

	switch(display) {

/* to be implemented? */
		/*case 1:
			printf("16x2 display unit, high-res.\n");
			do_summary16hn(fd);
			break;

		case 2:
			printf("16x2 display unit, high-res with net activity.\n");
			do_summary16h(fd);
			break;

		case 3:
			printf("16x2 display unit.\n");
			do_summary16(fd);
			break;

		case 4:
			printf("24x2 display unit, high-res with net activity and processes.\n");
			do_summary24(fd);
			break;

		case 5:
			printf("40x2 display unit, 1 CPU.\n");
			do_summary(fd);
			break;

		case 6:
			printf("40x2 display unit, 2 CPU's.\n");
			do_summary2(fd);
			break;
*/
		case 7:
			printf("Experimental templated display.\n");
			open_lcdrc(fd);
			break;
	}
}

int main(int argc,char *argv[])
{
	int fd, display = 0;

	init_cpustat();
	lcd_open(&fd);
	lcd_init(fd);
	usleep(100000);
	lcd_clear(fd);
	usleep(100000);
	init_charset(fd);
	
	if (argc < 2) {
		printf("Defaulting to ");

#ifdef LCDMODEDEFAULT
		display = LCDMODEDEFAULT;
#else
		display = 4;
#endif

		process_it(fd,display);
	}
	if (argc == 2) {
		display = atoi(argv[1]);
		if ((display > 7) || (display < 7 /* 1 */)) 
			help(argv); else process_it(fd,display);

	}

	close(fd);
	exit (0);
}
