/*

lcdgraph: positions real-time graphs on the display, sets up character sets.
Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

*/

#include "lcd.h"

void pos_graph_cpumem(int fd, int pass)
{
	int spot;
	char ln[10];
	spot=(te_cpu[pass][1] * 64) + te_cpu[pass][0];
	ln[0]=1; ln[1]=6; ln[2]=7; ln[3]=0;
	lcd_pos(fd, (spot & 0xff));
	lcd_write(fd, ln);
}

void pos_graph_net(int fd, int pass)
{
	int spot;
	char ln[10];
	spot=(te_net[pass][1] * 64) + te_net[pass][0];

	/* two writes are needed so we can pass a 0x00 do the display */
	ln[0]=0; ln[1]=0;
	lcd_pos(fd, (spot & 0xff));
	lcd_write(fd, ln);
	ln[0]=4; ln[1]=5; ln[2]=0;
	lcd_write(fd, ln);
}

/* set up special character set */
void init_charset (int fd)
{
  char tms[81];


sprintf(tms,
"%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "  X  ",   /* NET I/O LOADS */
    "  X  ",
    "  X  ",
    "     ",
    " XXX ",
    " X X ",
    " XXX ",
    "     "
);
dump_char_data (fd, tms, 0);

sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "XXXX ",  /* user */
    "X    ",  /* nice */
    "XXXX ",  /* sys  */
    "     ",
    "XX XX",
    "X X X",  /* MEM/SWAP */
    "X   X",
    "     "
);
dump_char_data (fd, tms, 8);


sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "XXXXX", /* RESERVED FOR LOAD */
    "XXXXX",
    "XXXXX",
    "XXXXX",
    "XXXXX",
    "XXXXX",
    "XXXXX",
    "     "
);
dump_char_data (fd, tms, 16);
dump_char_data (fd, tms, 24);

sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "     ", /* NET A */
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     "
);
dump_char_data (fd, tms, 32);

sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "     ", /* NET B */
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     "
);
dump_char_data (fd, tms, 40);

sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "     ", /* MEM A */
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     "
);
dump_char_data (fd, tms, 48);

sprintf(tms,
    "%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",

    "     ", /* MEM B */
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     ",
    "     "
);
dump_char_data (fd, tms, 56);

}
