/*

lcdload: load average status functions
Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

*/

#include "lcd.h"
static char  trend[2]="?";

/* returns the instantaneous load of the system */
double instload (char *pf)
{
	FILE *lf;
	double l=0, junk;
	lf=fopen (pf, "rt");
	fscanf (lf, "%lf %lf %lf", &l, &junk, &junk);
	fclose (lf);
	return l;
}


void drawload(int fd, int pass)
{
	char tms[81],ln[41], fill[6],
		erase[41]="                                        ";
	int i, spot;
	float divisor;
	double il;
	spot=(te_load[pass][1] * 64) + te_load[pass][0];
	/* set scale size */
	if(te_load[pass][3]<2) te_load[pass][3]=2; /* sanity */
/*	erase[te_load[pass][3]]=0x00; */
	divisor=100/(te_load[pass][3]*5);
	/* do load */
	il=instload("/proc/loadavg");
	il_f=modf(il, &il_w);
	if (il_l > il_f)
		trend[0]='D';
	if (il_l < il_f)
		trend[0]='U';
	il_l=il_f;
	il_f=il_f*(5*te_load[pass][3])+1;
	sprintf (ln, "L%s%3.3d", trend, (int) il_w);
	lcd_pos (fd, spot);
	lcd_write (fd, ln);

	strcpy (ln, erase);
	for (i=0;i<(int)il_f;i=i+5) ln[(i/5)]=3;
	ln[(int)(il_f/5)]=2; /* mark end with the line filler */
	/* if we overflowed, truncate string */
	ln[te_load[pass][3]]=0x00;
	lcd_write (fd, ln);

/* 
Fill the endcap
*/

	i=(int)((il_f/divisor)/5);
	sprintf(fill,"     ");
	for (;i>-1;i--) fill[i]='X';
		sprintf(tms,
		"%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s%5.5s",
		fill,
		fill,
		fill,
		fill,
		fill,
		fill,
		fill,
		"     ");
	dump_char_data (fd, tms, 16);
}

