/*

lcdmem: memory status functions
Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

*/

#include "lcd.h"

void memstat (long int *swapused, long int *swaptotal, long int *tot, long int *used, long int *bf, char *pf)
{
	FILE *mf;
	long int j;
	char ln[100];

	mf=fopen (pf, "rt");
	fgets (ln, 120, mf);
	fscanf (mf, "%s %li %li %li %li %li", ln, tot, used, &j, &j, bf);
	fscanf (mf, "%li", &j); /* toss cached entry */
	fscanf (mf,"%s %li %li %li",ln ,swapused, swaptotal, &j);
	fclose (mf);
}

void draw_memswap (int fd, int pass)
{
	long int swaptot, swapused, mem_tot, mem_used, mem_bf;
	int tnet;

	/* do memory */
	memstat (&swaptot, &swapused, &mem_tot, &mem_used, &mem_bf,
							"/proc/meminfo");

	/* swap */
	if(swaptot !=0){ 
	tnet = (double) swapused / (double) swaptot * 10;
	} else { tnet = 0; } /* woops! divide by zero :-D */
	
	/* plot 0 - 10 pixels */
	lcd_draw_bar(fd, tnet, 52);

	/* plot 0 - 10 pixels */
	lcd_draw_bar(fd, 
		((double) mem_bf / (double) mem_tot * 10 /* buffers */),
		53);
	
	/* plot 0 - 10 pixels */
	lcd_draw_bar(fd,
		((double) mem_used / (double) mem_tot * 10 /* user mem */),
		54);
}

