/*

lcdusers: users status functions
Copyleft 1997 Andrew J. Kroll (ag784@freenet.buffalo.edu)

*/

#include "lcd.h"

int numusers (char *utf)
/* returns # of users logged on */
{
	struct utmp *ut;
	int num=0;

	setutent();	 /* reset the utmp pointer to the beginning */

	do {
		ut = getutent();	/* Get the next utmp entry */
		if (ut == NULL || ut->ut_type != USER_PROCESS) continue;
		num++;
	} while (ut != NULL);

	if (num != last_users) {
#ifdef DEBUG
	printf("Number of users: %d\n", num);
#endif
	last_users = num;
	return(1); /* changed */
	}
	return(0); /* no change */
}


void draw_users(int fd,int pass)
{
	char ln[41];
	int nu=0;

	/* do users */

/*	if(nu=numusers(UTMP_FILE)) { 
we could do this, but it could mess stuff up at this time, because we don't
track the last position of printing... that will be a future optimization */

	nu=numusers(UTMP_FILE);
	sprintf (ln, "U%3d", last_users);
	/* recycle nu */
	nu=(te_users[pass][1] * 64) + te_users[pass][0];
	lcd_pos (fd, nu);
	lcd_write (fd, ln);
}
